/* cuser.cmd
 *
 * automatische User- und/oder Passwort-Verschuesselung 
 * 
 * 25.10.2000 
 *
 */

   call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
   call SysLoadFuncs

   encryptExe = "..\encrypt.exe"     /* Muss an Installation angepasst werden */

   cLine = arg(1)

   UserFlag = "N"

   do forever
      parse var cLine fName KeyWord

      if left(fName,1) = '-' | left(fName,1) = '/' then do
         /* Optionen auswerten */      
         if substr(fName,2) = "U" then UserFlag = "Y"
         else 
            say "Unknown option : " fName
         cLine = KeyWord
      end
      else
         leave
   end /* do */

   if KeyWord = '' | fName = '' then do
      say 'Usage  cuser [Options] UserFile "<Keyword>"'
      say '              Options:'
      say '                 /U  Also encrpyt user names'
      return
   end /* do */

   KeyWord = strip(KeyWord)
   KeyWord = strip(KeyWord,,'"')


   rc =  SysFileTree(fName,'files.',"FO")

  do i = 1 to files.0
     say 'Processing:' Files.i
     call EncryptUserFile Files.i,KeyWord,UserFlag
  end /* do */

  return

/**************************************************************************/


EncryptUserFile: procedure expose encryptExe

   fName   = arg(1)
   KeyWord = arg(2)
   flag    = arg(3)

   if flag = "Y" then
      pars = ":USERID:PASSWORD:"
   else
      pars = ":PASSWORD:"

   fTemp = 'ENCRYPT.TMP'
   fTemp1 = 'ENCRYPT.TM1'
   call SysFileDelete fTemp

   rc = stream(fName,'C','Open read')
   rc = stream(fTemp,'C','Open write')

   modified = 'N'

   do while chars(fName) > 0
      line = LineIn(fName)

      par = ''
      val = ''
      comment = ''

      line1 = translate(line,' ','09'x)
      parse var line1 par ':' val ' //' comment
      par = strip(par)
      val = strip(val)

      par1 = translate(par)||':'

      if val <> '' & pos(par1,pars) > 1 then do
         '@'||encryptExe '"'||KeyWord||'" "'||val||'" >'||fTemp1
         rc = stream(fTemp1,'C','Open read')
         eVal = linein(fTemp1)
         rc = stream(fTemp1,'C','close')

/*       call LineOut fTemp,'//'||line */
         
         i = pos(par,line)
         if substr(line,i,length(par)) == " " then delstr(line,i+length(par),1)
         line = insert('E',line,i-1)
                  
         i = pos(val,line)
         line = delstr(line,i,length(val))
         line = insert(eVal,line,i-1)

         modified = 'Y'
      
      end /* do */
      call LineOut fTemp,line
   end /* do */


   rc = stream(fName,'C','close')
   rc = stream(fTemp,'C','close')

   if modified = 'Y' then '@copy ' fTemp fName '>'||fTemp1
   call SysFileDelete fTemp
   call SysFileDelete fTemp1

return

